<?php
/**
 * InlineResponse2001ContentAllOf1
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse2001ContentAllOf1 Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse2001ContentAllOf1 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_1_content_allOf_1';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'modifiedBy' => 'int',
        'modifiedTime' => 'int',
        'modifiedText' => 'string',
        'numberOfDocuments' => 'int',
        'chats' => '\SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfChatsInner[]',
        'nextSupport' => '\SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfNextSupport',
        'remitterDepartmentName' => 'string',
        'remitterDepartmentId' => 'int',
        'internalContent' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'modifiedBy' => null,
        'modifiedTime' => 'timestamp',
        'modifiedText' => null,
        'numberOfDocuments' => null,
        'chats' => null,
        'nextSupport' => null,
        'remitterDepartmentName' => null,
        'remitterDepartmentId' => null,
        'internalContent' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'modifiedBy' => 'modifiedBy',
        'modifiedTime' => 'modifiedTime',
        'modifiedText' => 'modifiedText',
        'numberOfDocuments' => 'numberOfDocuments',
        'chats' => 'chats',
        'nextSupport' => 'nextSupport',
        'remitterDepartmentName' => 'remitterDepartmentName',
        'remitterDepartmentId' => 'remitterDepartmentId',
        'internalContent' => 'internalContent'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'modifiedBy' => 'setModifiedBy',
        'modifiedTime' => 'setModifiedTime',
        'modifiedText' => 'setModifiedText',
        'numberOfDocuments' => 'setNumberOfDocuments',
        'chats' => 'setChats',
        'nextSupport' => 'setNextSupport',
        'remitterDepartmentName' => 'setRemitterDepartmentName',
        'remitterDepartmentId' => 'setRemitterDepartmentId',
        'internalContent' => 'setInternalContent'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'modifiedBy' => 'getModifiedBy',
        'modifiedTime' => 'getModifiedTime',
        'modifiedText' => 'getModifiedText',
        'numberOfDocuments' => 'getNumberOfDocuments',
        'chats' => 'getChats',
        'nextSupport' => 'getNextSupport',
        'remitterDepartmentName' => 'getRemitterDepartmentName',
        'remitterDepartmentId' => 'getRemitterDepartmentId',
        'internalContent' => 'getInternalContent'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['modifiedBy'] = $data['modifiedBy'] ?? null;
        $this->container['modifiedTime'] = $data['modifiedTime'] ?? null;
        $this->container['modifiedText'] = $data['modifiedText'] ?? null;
        $this->container['numberOfDocuments'] = $data['numberOfDocuments'] ?? null;
        $this->container['chats'] = $data['chats'] ?? null;
        $this->container['nextSupport'] = $data['nextSupport'] ?? null;
        $this->container['remitterDepartmentName'] = $data['remitterDepartmentName'] ?? null;
        $this->container['remitterDepartmentId'] = $data['remitterDepartmentId'] ?? null;
        $this->container['internalContent'] = $data['internalContent'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets modifiedBy
     *
     * @return int|null
     */
    public function getModifiedBy()
    {
        return $this->container['modifiedBy'];
    }

    /**
     * Sets modifiedBy
     *
     * @param int|null $modifiedBy id of the employee who last modified this ticket
     *
     * @return self
     */
    public function setModifiedBy($modifiedBy)
    {
        $this->container['modifiedBy'] = $modifiedBy;

        return $this;
    }

    /**
     * Gets modifiedTime
     *
     * @return int|null
     */
    public function getModifiedTime()
    {
        return $this->container['modifiedTime'];
    }

    /**
     * Sets modifiedTime
     *
     * @param int|null $modifiedTime timestamp, when the ticket was last modified
     *
     * @return self
     */
    public function setModifiedTime($modifiedTime)
    {
        $this->container['modifiedTime'] = $modifiedTime;

        return $this;
    }

    /**
     * Gets modifiedText
     *
     * @return string|null
     */
    public function getModifiedText()
    {
        return $this->container['modifiedText'];
    }

    /**
     * Sets modifiedText
     *
     * @param string|null $modifiedText infos about the last change for this ticket
     *
     * @return self
     */
    public function setModifiedText($modifiedText)
    {
        $this->container['modifiedText'] = $modifiedText;

        return $this;
    }

    /**
     * Gets numberOfDocuments
     *
     * @return int|null
     */
    public function getNumberOfDocuments()
    {
        return $this->container['numberOfDocuments'];
    }

    /**
     * Sets numberOfDocuments
     *
     * @param int|null $numberOfDocuments number of documents for this ticket
     *
     * @return self
     */
    public function setNumberOfDocuments($numberOfDocuments)
    {
        $this->container['numberOfDocuments'] = $numberOfDocuments;

        return $this;
    }

    /**
     * Gets chats
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfChatsInner[]|null
     */
    public function getChats()
    {
        return $this->container['chats'];
    }

    /**
     * Sets chats
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfChatsInner[]|null $chats list of chat ids for this ticket
     *
     * @return self
     */
    public function setChats($chats)
    {
        $this->container['chats'] = $chats;

        return $this;
    }

    /**
     * Gets nextSupport
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfNextSupport|null
     */
    public function getNextSupport()
    {
        return $this->container['nextSupport'];
    }

    /**
     * Sets nextSupport
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse2001ContentAllOfNextSupport|null $nextSupport nextSupport
     *
     * @return self
     */
    public function setNextSupport($nextSupport)
    {
        $this->container['nextSupport'] = $nextSupport;

        return $this;
    }

    /**
     * Gets remitterDepartmentName
     *
     * @return string|null
     */
    public function getRemitterDepartmentName()
    {
        return $this->container['remitterDepartmentName'];
    }

    /**
     * Sets remitterDepartmentName
     *
     * @param string|null $remitterDepartmentName If the remitter is assigned to a department, returns the name of the department
     *
     * @return self
     */
    public function setRemitterDepartmentName($remitterDepartmentName)
    {
        $this->container['remitterDepartmentName'] = $remitterDepartmentName;

        return $this;
    }

    /**
     * Gets remitterDepartmentId
     *
     * @return int|null
     */
    public function getRemitterDepartmentId()
    {
        return $this->container['remitterDepartmentId'];
    }

    /**
     * Sets remitterDepartmentId
     *
     * @param int|null $remitterDepartmentId If the remitter is assigned to a department, returns the id of the department
     *
     * @return self
     */
    public function setRemitterDepartmentId($remitterDepartmentId)
    {
        $this->container['remitterDepartmentId'] = $remitterDepartmentId;

        return $this;
    }

    /**
     * Gets internalContent
     *
     * @return string|null
     */
    public function getInternalContent()
    {
        return $this->container['internalContent'];
    }

    /**
     * Sets internalContent
     *
     * @param string|null $internalContent returns the internal content if the user has right to
     *
     * @return self
     */
    public function setInternalContent($internalContent)
    {
        $this->container['internalContent'] = $internalContent;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


